﻿'////////////////////////////////////////////////////////////////////////////////////////////////////
'//// Copyright(c) HNS Co., Ltd. All rights reserved
'//// HNS Site 주소 : https://www.hnsts.co.kr
'//// SmartX New Framework Reference Guide : https://www.smartx.co.kr
'/////////////////////////////////////////////////// [저작권] ///////////////////////////////////////
'//// 본 자료(소스 및 이미지)의 저작권은 ㈜에이치앤에스에 있습니다. 
'//// 본 자료는 개발하시는데 참고자료 용도로 사용하실 수 있으며 저작권 표시 없이 복사,게재, 
'//// 출판 하실 수 없습니다. 외부 게재 사용 시 반드시 출처 항목에 회사명과 사이트 주소를 
'//// 반드시 명시해 주시기 바랍니다.
'//// [표기 예] 출처 : ㈜에이치앤에스(www.hnsts.co.kr) 또는 ㈜HNS(www.hnsts.co.kr)
'//// 단, 프로그램을 개발할 때는 참고용으로 사용하셔도 됩니다.
'//////////////////////////////////////////// [수정 및 업데이트] ////////////////////////////////////
'//// [중요] 소스코드는 참고 및 학습용으로 버그 및 여러가지 문제가 있을 수 있습니다.
'//// 제품 개발 시 내용과 예제 코드는 수정 및 검증작업을 직접 하셔야 하며 문제 발생에 
'//// 대한 책임은 ㈜HNS사와 무관합니다.
'//// 본사는 자료를 최신내용으로 유지하기 위해 노력하고 있으며 제공되는 정보의 오류 및 
'//// 개선이 필요할 경우 사전 공지 없이 업데이트 될 수 있습니다. 
'//// 본 자료(소스 및 이미지)의 문제점 발견 시 본사로 문의주시면 검토하여 자료를 수정하도록 
'//// 하겠습니다.
'//// 최신 수정일 : 2025.06.12
'////////////////////////////////////////////////// [문의방법] //////////////////////////////////////
'//// 1. 전화 : 02-6402-8001 (H/W : 2번, S/W : 3번)
'//// 2. E-Mail : app@smartx.co.kr
'//// 3. QnA : https://www.hnsts.co.kr/Community/QnA
'/////////////////////////////////////////////// [프로그램 설명] ////////////////////////////////////
'//// 프로그램 이름 : Byte Convertor(Byte to Structure)
'//// 프로그램 설명 : Structure 형식을 Byte(Binary)로 바꿔 그 값을 시리얼 통신을 통해 전송하고 전송받은 값을
'//// 다시 구조체로 바꿔 주는 예제 프로그램입니다.

'//// 사용된 SmartX Framework Version : 5.0.0.12
'////////////////////////////////////////////////////////////////////////////////////////////////////

Imports System
Imports System.IO
Imports System.Drawing
Imports System.Windows.Forms
Imports SmartX
Imports System.Text

Public Class Form1
    Inherits Form

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Structure StructureData
        ' 채널
        Public iCh As Integer
        ' 온도
        Public fTem As Single
        ' 메세지 길이
        Public byMsgLen As Byte
        ' 메세지
        Public strMsg As String
    End Structure

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        smartForm1.MainForm = Me
        ' 콤보박스 설정
        cmbBaudRate.ItemList.AddItem("110")
        cmbBaudRate.ItemList.AddItem("300")
        cmbBaudRate.ItemList.AddItem("600")
        cmbBaudRate.ItemList.AddItem("1200")
        cmbBaudRate.ItemList.AddItem("2400")
        cmbBaudRate.ItemList.AddItem("4800")
        cmbBaudRate.ItemList.AddItem("9600")
        cmbBaudRate.ItemList.AddItem("14400")
        cmbBaudRate.ItemList.AddItem("19200")
        cmbBaudRate.ItemList.AddItem("38400")
        cmbBaudRate.ItemList.AddItem("57600")
        cmbBaudRate.ItemList.AddItem("115200")

        cmbPortNo.ItemList.AddItem("COM1")
        cmbPortNo.ItemList.AddItem("COM2")
        cmbPortNo.ItemList.AddItem("COM3")
        cmbPortNo.ItemList.AddItem("COM4")

        ' 초기값 설정
        cmbBaudRate.SelectItemIndex = 6
        cmbPortNo.SelectItemIndex = 2

        ' 리스트박스 설정
        Dim reColumStyle(2) As SmartListBox.COLUMNSTYLE
        reColumStyle(0).iColumnWidth = 112
        reColumStyle(0).eColumnAlign = SmartListBox.COLUMNALIGNS.CENTER
        reColumStyle(0).iOffsetColumn = 0

        reColumStyle(1).iColumnWidth = 163
        reColumStyle(1).eColumnAlign = SmartListBox.COLUMNALIGNS.CENTER
        reColumStyle(1).iOffsetColumn = 0

        reColumStyle(2).iColumnWidth = 386
        reColumStyle(2).eColumnAlign = SmartListBox.COLUMNALIGNS.CENTER
        reColumStyle(2).iOffsetColumn = 0
        lsbReceiveData.ColumnStyles = reColumStyle

        ' 시리얼 통신
        smartSerialPort1.ErrorCheckCodeType = SmartSerialPort.ERRORCHECKCODETYPES.BINARY
        smartSerialPort1.ErrorCheckMode = SmartSerialPort.ERRORCHECK.NONE
        smartSerialPort1.ErrorCode_Location = SmartSerialPort.ERRORCODELOCATION.TAIL
        smartSerialPort1.ReceiveFrameDebugMode = False
        smartSerialPort1.RS485SoftwareDetection = False
        smartSerialPort1.FrameBufferSize = 50000
        smartSerialPort1.ReadTimeout = 100
        smartSerialPort1.FrameSeparationType = SmartSerialPort.FRAMESEPARATIONTYPES.STXANDETX
        smartSerialPort1.ReceiveDetect = SmartSerialPort.RECEIVEDETECTTYPE.EVENT_QUEUE
        smartSerialPort1.STXCode = &H2
        smartSerialPort1.ETXCode = &H3

        ' 로딩화면에 키보드 표시
        smartKeyboard1.Show(390, 134, labMessage)
    End Sub
    ' 인자로 변환될 구조체 데이터를 입력하면 바이트 배열을 리턴한다.
    Private Function structureToByte(ByVal stData As StructureData) As Byte()
        ' 전체 바이트 배열 크기 계산:
        ' int(4) + float(4) + byte(1) + 유니코드 문자열(sd1.sC.Length * 2)
        Dim byteStream As Byte() = New Byte(4 + 4 + 1 + stData.strMsg.Length * 2 - 1) {}
        ' 유니코드 문자열 길이(문자 수 × 2)
        stData.byMsgLen = CByte(stData.strMsg.Length * 2)

        '구조체 멤버 각각 byte 배열로 변환하여 하나의 스트림(1차원 배열)로 만들기 위해 복사한다.
        ' 채널(정수형) 바이트로 변환 및 복사
        Array.Copy(BitConverter.GetBytes(stData.iCh), 0, byteStream, 0, 4)
        ' 온도(실수형) 바이트로 변환 및 복사
        Array.Copy(BitConverter.GetBytes(stData.fTem), 0, byteStream, 4, 4)
        ' 문자열(메세지) 바이트로 변환 및 복사
        Array.Copy(Encoding.Unicode.GetBytes(stData.strMsg), 0, byteStream, 9, stData.strMsg.Length * 2)

        ' 일반적으로 문자열의 끝을 NULL 문자를 확인하여 구분하지만, BinaryReader.RedString 메소드는 문자열 앞부분에
        ' 1 byte로 인코딩된 길이가 포함되어 인코딩됩니다. 
        ' 자세한 내용은 MSDN을 참고하시기 바랍니다.
        byteStream(8) = stData.byMsgLen

        Return byteStream
    End Function
    ' 인자로 변환될 바이트 배열을 입력하면 구조체 데이터를 리턴한다.
    Private Function byteToStructure(ByVal byData As Byte()) As StructureData
        Dim structData As New StructureData()
        ' 기본 데이터 형식을 특정 인코딩의 이진값으로 읽음
        Using reader As New BinaryReader(New MemoryStream(byData, False), Encoding.Unicode)
            ' 현재 스트림에서 부호있는 4바이트 정수를 읽기(iCh)
            structData.iCh = reader.ReadInt32()
            ' 현재 스트림에서 4바이트 부동 소수점값을 읽기(fTem)
            structData.fTem = reader.ReadSingle()
            ' 현재 스트림에서 지정된 문자열 길이 읽기
            structData.strMsg = reader.ReadString()
        End Using
        Return structData
    End Function
    ' send 버튼을 클릭 했을 때 설정값
    Private Sub butSend_Click(ByVal sender As Object, ByVal e As EventArgs) Handles butSend.Click
        If smartSerialPort1.IsOpen Then
            Dim stData As New StructureData()
            stData.iCh = CInt(labChannel.Text)
            stData.fTem = CSng(labTemp.Text)
            stData.strMsg = labMessage.Text()
            Dim byte_stData As Byte() = structureToByte(stData)
            smartSerialPort1.WriteFrame(byte_stData)
        Else
            SmartMessageBox.Show("포트를 오픈 해주시기 바랍니다.")
        End If
    End Sub
    ' 데이터가 수신되면 구조체를 리스트박스에 출력 한다.
    Private Sub smartSerialPort1_OnReadQueueEvent() Handles smartSerialPort1.OnReadQueueEvent
        ' 수신 초기값 empty
        Dim PortStatus As SmartSerialPort.FRAMEDATAREADSTATUS = SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY
        ' byte 배열에 저장
        Dim bReadByte() As Byte = Nothing
        ' 수신 받은 데이터를 저장
        PortStatus = smartSerialPort1.ReadQueue(bReadByte)

        If PortStatus = SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY Then
            lsbReceiveData.AddItem("EMPTY")
        ElseIf PortStatus = SmartSerialPort.FRAMEDATAREADSTATUS.FAILDATA Then
            lsbReceiveData.AddItem("Fail")
        Else
            ' 수신받은 구조체를 저장
            Dim structData As StructureData = byteToStructure(bReadByte)
            ' 구조체 출력
            Dim strColumnItems(2) As String
            strColumnItems(0) = structData.iCh.ToString()
            strColumnItems(1) = structData.fTem.ToString()
            strColumnItems(2) = structData.strMsg
            lsbReceiveData.AddItem(strColumnItems)
        End If
    End Sub
    ' 라벨 클릭 시 클릭된 라벨의 키보드를 출력 하고 크기와 입력 대상을 설정한다.
    Private Sub SmartLabels_Click(ByVal sender As Object, ByVal e As EventArgs) Handles labTemp.Click, labMessage.Click, labChannel.Click
        If sender Is labChannel Then
            smartKeyboard1.Size = New Size(160, 160)
            smartKeyboard1.SizeRunTime = New Size(160, 160)
            smartKeyboard1.KeyboardType = SmartKeyboard.KEYBOARDTYPES.NUMERICAL
            smartKeyboard1.Show(390, 134, labChannel)
            smartKeyboard1.ReDraw()
        ElseIf sender Is labTemp Then
            smartKeyboard1.Size = New Size(160, 160)
            smartKeyboard1.SizeRunTime = New Size(160, 160)
            smartKeyboard1.KeyboardType = SmartKeyboard.KEYBOARDTYPES.NUMERICAL
            smartKeyboard1.Show(390, 134, labTemp)
            smartKeyboard1.ReDraw()
        Else
            smartKeyboard1.Size = New Size(400, 161)
            smartKeyboard1.SizeRunTime = New Size(400, 161)
            smartKeyboard1.KeyboardType = SmartKeyboard.KEYBOARDTYPES.NORMAL
            smartKeyboard1.Show(390, 134, labMessage)
            smartKeyboard1.ReDraw()
        End If
    End Sub
    ' Open버튼 클릭 시 포트가 오픈된다.
    Private Sub butPortOpen_Click(ByVal sender As Object, ByVal e As EventArgs) Handles butPortOpen.Click
        If smartSerialPort1.IsOpen = False Then
            smartSerialPort1.Open()
            SmartX.SmartMessageBox.Show("포트 오픈")
        End If
    End Sub
    ' BaudRate 콤보박스 조작 시 BaudRate를 설정한다.
    Private Sub cmbBaudRate_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbBaudRate.SelectedIndexChanged
        If cmbBaudRate.SelectItemIndex = -1 Then Return
        smartSerialPort1.Baud_Rate = CType(Convert.ToInt32(cmbBaudRate.Text), SmartSerialPort.BAUDRATE)
    End Sub
    ' PortNo 콤보박스 조작 시 포트넘버를 설정한다.
    Private Sub cmbPortNo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbPortNo.SelectedIndexChanged
        If cmbPortNo.SelectItemIndex <> -1 Then
            smartSerialPort1.PortNo = CType((cmbPortNo.SelectItemIndex + 1), SmartX.SmartSerialPort.COMPORTNO)
        End If
    End Sub
    ' Clear 버튼 클릭 시 ListBox에 출력된 값이 지워진다.
    Private Sub butlsbClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butlsbClear.Click
        lsbReceiveData.ClearAll()
    End Sub
    ' Close버튼 클릭 시 포트가 닫힌다.
    Private Sub butPortClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butPortClose.Click
        If smartSerialPort1.IsOpen Then
            smartSerialPort1.Close()
        End If
    End Sub
End Class
