﻿////////////////////////////////////////////////////////////////////////////////////////////////////
//// Copyright(c) HNS Co., Ltd. All rights reserved
//// HNS Site 주소 : https://www.hnsts.co.kr
//// SmartX New Framework Reference Guide : https://www.smartx.co.kr
/////////////////////////////////////////////////// [저작권] ///////////////////////////////////////
//// 본 자료(소스 및 이미지)의 저작권은 ㈜에이치앤에스에 있습니다. 
//// 본 자료는 개발하시는데 참고자료 용도로 사용하실 수 있으며 저작권 표시 없이 복사,게재, 
//// 출판 하실 수 없습니다. 외부 게재 사용 시 반드시 출처 항목에 회사명과 사이트 주소를 
//// 반드시 명시해 주시기 바랍니다.
//// [표기 예] 출처 : ㈜에이치앤에스(www.hnsts.co.kr) 또는 ㈜HNS(www.hnsts.co.kr)
//// 단, 프로그램을 개발할 때는 참고용으로 사용하셔도 됩니다.
//////////////////////////////////////////// [수정 및 업데이트] ////////////////////////////////////
//// [중요] 소스코드는 참고 및 학습용으로 버그 및 여러가지 문제가 있을 수 있습니다.
//// 제품 개발 시 내용과 예제 코드는 수정 및 검증작업을 직접 하셔야 하며 문제 발생에 
//// 대한 책임은 ㈜HNS사와 무관합니다.
//// 본사는 자료를 최신내용으로 유지하기 위해 노력하고 있으며 제공되는 정보의 오류 및 
//// 개선이 필요할 경우 사전 공지 없이 업데이트 될 수 있습니다. 
//// 본 자료(소스 및 이미지)의 문제점 발견 시 본사로 문의주시면 검토하여 자료를 수정하도록 
//// 하겠습니다.
//// 최신 수정일 : 2025.06.12
////////////////////////////////////////////////// [문의방법] //////////////////////////////////////
//// 1. 전화 : 02-6402-8001 (H/W : 2번, S/W : 3번)
//// 2. E-Mail : app@smartx.co.kr
//// 3. QnA : https://www.hnsts.co.kr/Community/QnA
/////////////////////////////////////////////// [프로그램 설명] ////////////////////////////////////
//// 프로그램 이름 : ByteConvertor(Byte to Structure)
//// 프로그램 설명 : Structure 형식을 Byte(Binary)로 바꿔 그 값을 시리얼 통신을 통해 전송하고 전송받은 값을
//// 다시 구조체로 바꿔 주는 예제 프로그램입니다.

//// 사용된 SmartX Framework Version : 5.0.0.12
////////////////////////////////////////////////////////////////////////////////////////////////////

using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace TechNote71_Example_Csharp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        
        private struct StructureData
        {
            //채널
            public int iCh;
            //온도
            public float fTemp;
            //메세지 길이
            public byte byMsgLen;
            //메세지
            public string strMsg;
        }
                
        // 폼 로드시 발생되는 이벤트
        private void Form1_Load(object sender, EventArgs e)
        {
            smartForm1.MainForm = this;
            // 콤보박스 설정
            cmbBaudRate.ItemList.AddItem("110");
            cmbBaudRate.ItemList.AddItem("300");
            cmbBaudRate.ItemList.AddItem("600");
            cmbBaudRate.ItemList.AddItem("1200");
            cmbBaudRate.ItemList.AddItem("2400");
            cmbBaudRate.ItemList.AddItem("4800");
            cmbBaudRate.ItemList.AddItem("9600");
            cmbBaudRate.ItemList.AddItem("14400");
            cmbBaudRate.ItemList.AddItem("19200");
            cmbBaudRate.ItemList.AddItem("38400");
            cmbBaudRate.ItemList.AddItem("57600");
            cmbBaudRate.ItemList.AddItem("115200");

            cmbPortNo.ItemList.AddItem("COM1");
            cmbPortNo.ItemList.AddItem("COM2");
            cmbPortNo.ItemList.AddItem("COM3");
            cmbPortNo.ItemList.AddItem("COM4");

            // 초기값 설정
            cmbBaudRate.SelectItemIndex = 6;
            cmbPortNo.SelectItemIndex = 2;

            // 리스트박스 설정
            SmartX.SmartListBox.COLUMNSTYLE[] lsbColumStyle = new SmartX.SmartListBox.COLUMNSTYLE[3];
            lsbColumStyle[0].iColumnWidth = 112;
            lsbColumStyle[0].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
            lsbColumStyle[0].iOffsetColumn = 0;

            lsbColumStyle[1].iColumnWidth = 163;
            lsbColumStyle[1].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
            lsbColumStyle[1].iOffsetColumn = 0;

            lsbColumStyle[2].iColumnWidth = 386;
            lsbColumStyle[2].eColumnAlign = SmartX.SmartListBox.COLUMNALIGNS.CENTER;
            lsbColumStyle[2].iOffsetColumn = 0;
            lsbReceiveData.ColumnStyles = lsbColumStyle;

            //시리얼 통신
            smartSerialPort1.ErrorCheckCodeType = SmartX.SmartSerialPort.ERRORCHECKCODETYPES.BINARY;
            smartSerialPort1.ErrorCheckMode = SmartX.SmartSerialPort.ERRORCHECK.NONE;
            smartSerialPort1.ErrorCode_Location = SmartX.SmartSerialPort.ERRORCODELOCATION.TAIL;
            smartSerialPort1.ReceiveFrameDebugMode = false;
            smartSerialPort1.RS485SoftwareDetection = false;
            smartSerialPort1.FrameBufferSize = 50000;
            smartSerialPort1.ReadTimeout = 100;
            smartSerialPort1.FrameSeparationType = SmartX.SmartSerialPort.FRAMESEPARATIONTYPES.STXANDETX;
            smartSerialPort1.ReceiveDetect = SmartX.SmartSerialPort.RECEIVEDETECTTYPE.EVENT_QUEUE;
            smartSerialPort1.STXCode = 0x02;
            smartSerialPort1.ETXCode = 0x03;

            //로딩 화면에 키보드 표시
            smartKeyboard1.Show(390, 134, labMessage);
        }

        // 인자로 변환될 구조체 데이터를 입력하면 바이트 배열을 리턴한다.
        private byte[] StructureToByte(StructureData stData)
        {
            // 전체 바이트 배열 크기 계산:
            // int(4) + float(4) + byte(1) + 유니코드 문자열(sd1.sC.Length * 2)
            byte[] byteStream = new byte[sizeof(int) + sizeof(float) + sizeof(byte) + (stData.strMsg.Length * 2)];
            // 유니코드 문자열 길이(문자 수 × 2)
            stData.byMsgLen = (byte)(stData.strMsg.Length * 2);

            // 구조체 멤버 각각 Byte 배열로 변환하여 하나의 스트림(1차원 배열)로 만들기 위해 복사한다.
            // 채널(정수형) 바이트로 변환 및 복사
            Array.Copy(BitConverter.GetBytes(stData.iCh), 0, byteStream, 0, sizeof(int));
            // 온도(실수형) 바이트로 변환 및 복사
            Array.Copy(BitConverter.GetBytes(stData.fTemp), 0, byteStream, sizeof(int), sizeof(float));
            // 문자열(메세지) 바이트로 변환 및 복사
            Array.Copy(Encoding.Unicode.GetBytes(stData.strMsg), 0, byteStream, sizeof(int) + sizeof(float) + sizeof(byte), (stData.strMsg.Length * 2));

            // 일반적으로 문자열의 끝을 NULL 문자를 확인하여 구분하지만, BinaryReader.RedString 메소드는 문자열 앞부분에
            // 1 byte로 인코딩된 길이가 포함되어 인코딩됩니다. 
            // 자세한 내용은 MSDN을 참고하시기 바랍니다.
            byteStream[sizeof(int) + sizeof(float)] = stData.byMsgLen;

            return byteStream;
        }
        // 인자로 변환될 바이트 배열을 입력하면 구조체 데이터를 리턴한다.
        StructureData ByteToStructure(byte[] byData)
        {
            StructureData structData = new StructureData();
            // 기본 데이터 형식을 특정 인코딩의 이진값으로 읽음
            using (BinaryReader reader = new BinaryReader(new MemoryStream(byData, false), Encoding.Unicode))
            {
                // 현재 스트림에서 부호있는 4바이트 정수를 읽기(iCh)
                structData.iCh = reader.ReadInt32();
                // 현재 스트림에서 4바이트 부동 소수점값을 읽기(fTem)
                structData.fTemp = reader.ReadSingle();
                // 현재 스트림에서 지정된 문자열 길이 읽기(strMsg)
                structData.strMsg = reader.ReadString();
            }
            return structData;
        }
        // send 버튼을 클릭 했을 때 설정값
        private void butSend_Click(object sender, EventArgs e)
        {
            if (smartSerialPort1.IsOpen == true)
            {
                StructureData stData = new StructureData();
                stData.iCh = Convert.ToInt32(labChannel.Text);
                stData.fTemp = Convert.ToSingle(labTemp.Text);
                stData.strMsg = labMessage.Text;
                byte[] byte_stData = StructureToByte(stData);
                smartSerialPort1.WriteFrame(byte_stData);
            }
            else
            {
                SmartX.SmartMessageBox.Show("포트를 오픈 해주시기 바랍니다.");
            }
        }
        // 데이터가 수신되면 구조체를 리스트박스에 출력 한다.
        private void smartSerialPort1_OnReadQueueEvent()
        {
            // 수신 초기값 empty
            SmartX.SmartSerialPort.FRAMEDATAREADSTATUS PortStatus = SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY;
            //byte 배열에 저장
            byte[] byReadData;
            //수신 받은 데이터를 저장
            PortStatus = smartSerialPort1.ReadQueue(out byReadData);

            if (PortStatus == SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.EMPTY)
            {
                lsbReceiveData.AddItem("EMPTY");
            }
            else if (PortStatus == SmartX.SmartSerialPort.FRAMEDATAREADSTATUS.FAILDATA)
            {
                lsbReceiveData.AddItem("Fail");
            }
            else
            {
                //수신 받은 구조체를 저장
                StructureData structData = ByteToStructure(byReadData);
                                
                //구조체 출력
                string[] strColumnItems = new string[3];
                strColumnItems[0] = structData.iCh.ToString();
                strColumnItems[1] = structData.fTemp.ToString();
                strColumnItems[2] = structData.strMsg;
                lsbReceiveData.AddItem(strColumnItems);
            }
        }
        // 라벨 클릭 시 클릭된 라벨의 키보드를 출력 하고 크기와 입력 대상을 설정한다.
        private void SmartLabels_Click(object sender, EventArgs e)
        {
            if (sender == labChannel)
            {
                smartKeyboard1.Size = new Size(160, 160);
                smartKeyboard1.SizeRunTime = new Size(160, 160);
                smartKeyboard1.KeyboardType = SmartX.SmartKeyboard.KEYBOARDTYPES.NUMERICAL;
                smartKeyboard1.Show(390, 134, labChannel);
            }
            else if (sender == labTemp)
            {
                smartKeyboard1.Size = new Size(160, 160);
                smartKeyboard1.SizeRunTime = new Size(160, 160);
                smartKeyboard1.KeyboardType = SmartX.SmartKeyboard.KEYBOARDTYPES.NUMERICAL;
                smartKeyboard1.Show(390, 134, labTemp);
            }
            else
            {
                smartKeyboard1.Size = new Size(400, 161);
                smartKeyboard1.SizeRunTime = new Size(400, 161);
                smartKeyboard1.KeyboardType = SmartX.SmartKeyboard.KEYBOARDTYPES.NORMAL;
                smartKeyboard1.Show(390, 134, labMessage);
            }
        }
        // Open버튼 클릭 시 포트가 오픈된다.
        private void butPortOpen_Click(object sender, EventArgs e)
        {
            if (smartSerialPort1.IsOpen == false)
            {
                smartSerialPort1.Open();
                SmartX.SmartMessageBox.Show("포트 오픈");
            }
        }
        // Close버튼 클릭 시 포트가 닫힌다.
        private void butPortClose_Click(object sender, EventArgs e)
        {
            if (smartSerialPort1.IsOpen == true)
            {
                smartSerialPort1.Close();
            }
        }
        // Clear 버튼 클릭 시 ListBox에 출력된 값이 지워진다.
        private void butlsbClear_Click(object sender, EventArgs e)
        {
            lsbReceiveData.ClearAll();
        }
        // BaudRate 콤보박스 조작 시 BaudRate를 설정한다.
        private void cmbBaudRate_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmbBaudRate.SelectItemIndex == -1)
            {
                return;
            }
            if (cmbBaudRate.SelectItemIndex != -1)
            {
                smartSerialPort1.Baud_Rate = (SmartX.SmartSerialPort.BAUDRATE)Convert.ToInt32(cmbBaudRate.Text);
            }
        }
        // PortNo 콤보박스 조작 시 포트넘버를 설정한다.
        private void cmbPortNo_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmbPortNo.SelectItemIndex != -1)
            {
                smartSerialPort1.PortNo = (SmartX.SmartSerialPort.COMPORTNO)(cmbPortNo.SelectItemIndex+1);
            }
        }

        private void cmbPortNo_Click(object sender, EventArgs e)
        {

        }
    }
}